"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
import dateutil.parser
from enum import Enum
from orq_python_client import utils
from orq_python_client.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_python_client.utils import FieldMetadata, PathParamMetadata
from pydantic import model_serializer
from typing import List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypedDict


class GetV2ResourcesDatasetsDatasetIDRowsRowIDRequestTypedDict(TypedDict):
    dataset_id: str
    r"""Dataset ID"""
    row_id: str
    r"""Dataset row ID"""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDRequest(BaseModel):
    dataset_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Dataset ID"""

    row_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Dataset row ID"""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDResourcesResponseBodyData(BaseModel):
    message: str


class GetV2ResourcesDatasetsDatasetIDRowsRowIDResourcesResponseBody(Exception):
    r"""Dataset row not found with the given id"""

    data: GetV2ResourcesDatasetsDatasetIDRowsRowIDResourcesResponseBodyData

    def __init__(
        self, data: GetV2ResourcesDatasetsDatasetIDRowsRowIDResourcesResponseBodyData
    ):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, GetV2ResourcesDatasetsDatasetIDRowsRowIDResourcesResponseBodyData
        )


class GetV2ResourcesDatasetsDatasetIDRowsRowIDRole(str, Enum):
    r"""The role of the prompt message"""

    SYSTEM = "system"
    ASSISTANT = "assistant"
    USER = "user"
    EXCEPTION = "exception"
    TOOL = "tool"
    PROMPT = "prompt"
    CORRECTION = "correction"
    EXPECTED_OUTPUT = "expected_output"


class GetV2ResourcesDatasetsDatasetIDRowsRowID2ResourcesType(str, Enum):
    IMAGE_URL = "image_url"


class GetV2ResourcesDatasetsDatasetIDRowsRowID2ImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""
    id: NotRequired[str]
    r"""The orq.ai id of the image"""
    detail: NotRequired[str]
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class GetV2ResourcesDatasetsDatasetIDRowsRowID2ImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""

    id: Optional[str] = None
    r"""The orq.ai id of the image"""

    detail: Optional[str] = None
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class GetV2ResourcesDatasetsDatasetIDRowsRowID22TypedDict(TypedDict):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: GetV2ResourcesDatasetsDatasetIDRowsRowID2ResourcesType
    image_url: GetV2ResourcesDatasetsDatasetIDRowsRowID2ImageURLTypedDict


class GetV2ResourcesDatasetsDatasetIDRowsRowID22(BaseModel):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: GetV2ResourcesDatasetsDatasetIDRowsRowID2ResourcesType

    image_url: GetV2ResourcesDatasetsDatasetIDRowsRowID2ImageURL


class GetV2ResourcesDatasetsDatasetIDRowsRowID2Type(str, Enum):
    TEXT = "text"


class GetV2ResourcesDatasetsDatasetIDRowsRowID21TypedDict(TypedDict):
    r"""Text content part of a prompt message"""

    type: GetV2ResourcesDatasetsDatasetIDRowsRowID2Type
    text: str


class GetV2ResourcesDatasetsDatasetIDRowsRowID21(BaseModel):
    r"""Text content part of a prompt message"""

    type: GetV2ResourcesDatasetsDatasetIDRowsRowID2Type

    text: str


GetV2ResourcesDatasetsDatasetIDRowsRowIDContent2TypedDict = Union[
    GetV2ResourcesDatasetsDatasetIDRowsRowID21TypedDict,
    GetV2ResourcesDatasetsDatasetIDRowsRowID22TypedDict,
]


GetV2ResourcesDatasetsDatasetIDRowsRowIDContent2 = Union[
    GetV2ResourcesDatasetsDatasetIDRowsRowID21,
    GetV2ResourcesDatasetsDatasetIDRowsRowID22,
]


GetV2ResourcesDatasetsDatasetIDRowsRowIDContentTypedDict = Union[
    str, List[GetV2ResourcesDatasetsDatasetIDRowsRowIDContent2TypedDict]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


GetV2ResourcesDatasetsDatasetIDRowsRowIDContent = Union[
    str, List[GetV2ResourcesDatasetsDatasetIDRowsRowIDContent2]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDType(str, Enum):
    FUNCTION = "function"


class GetV2ResourcesDatasetsDatasetIDRowsRowIDFunctionTypedDict(TypedDict):
    name: str
    arguments: str
    r"""JSON string arguments for the functions"""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDFunction(BaseModel):
    name: str

    arguments: str
    r"""JSON string arguments for the functions"""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDToolCallsTypedDict(TypedDict):
    type: GetV2ResourcesDatasetsDatasetIDRowsRowIDType
    function: GetV2ResourcesDatasetsDatasetIDRowsRowIDFunctionTypedDict
    id: NotRequired[str]
    index: NotRequired[float]


class GetV2ResourcesDatasetsDatasetIDRowsRowIDToolCalls(BaseModel):
    type: GetV2ResourcesDatasetsDatasetIDRowsRowIDType

    function: GetV2ResourcesDatasetsDatasetIDRowsRowIDFunction

    id: Optional[str] = None

    index: Optional[float] = None


class GetV2ResourcesDatasetsDatasetIDRowsRowIDMessagesTypedDict(TypedDict):
    role: GetV2ResourcesDatasetsDatasetIDRowsRowIDRole
    r"""The role of the prompt message"""
    content: GetV2ResourcesDatasetsDatasetIDRowsRowIDContentTypedDict
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""
    tool_calls: NotRequired[
        List[GetV2ResourcesDatasetsDatasetIDRowsRowIDToolCallsTypedDict]
    ]


class GetV2ResourcesDatasetsDatasetIDRowsRowIDMessages(BaseModel):
    role: GetV2ResourcesDatasetsDatasetIDRowsRowIDRole
    r"""The role of the prompt message"""

    content: GetV2ResourcesDatasetsDatasetIDRowsRowIDContent
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""

    tool_calls: Optional[List[GetV2ResourcesDatasetsDatasetIDRowsRowIDToolCalls]] = None


class GetV2ResourcesDatasetsDatasetIDRowsRowIDResponseBodyTypedDict(TypedDict):
    r"""Returned dataset row model from the API."""

    id: str
    messages: List[GetV2ResourcesDatasetsDatasetIDRowsRowIDMessagesTypedDict]
    r"""Input message(s) of the dataset row"""
    expected_output: NotRequired[Nullable[str]]
    r"""Reference of the dataset row"""
    created: NotRequired[datetime]
    r"""The date and time the resource was created"""
    updated: NotRequired[datetime]
    r"""The date and time the resource was last updated"""


class GetV2ResourcesDatasetsDatasetIDRowsRowIDResponseBody(BaseModel):
    r"""Returned dataset row model from the API."""

    id: str

    messages: List[GetV2ResourcesDatasetsDatasetIDRowsRowIDMessages]
    r"""Input message(s) of the dataset row"""

    expected_output: OptionalNullable[str] = UNSET
    r"""Reference of the dataset row"""

    created: Optional[datetime] = None
    r"""The date and time the resource was created"""

    updated: Optional[datetime] = dateutil.parser.isoparse("2024-10-14T12:39:38.949Z")
    r"""The date and time the resource was last updated"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["expected_output", "created", "updated"]
        nullable_fields = ["expected_output"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
