"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from orq_python_client.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_python_client.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from pydantic import model_serializer
from typing import List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypedDict


class PostV2ResourcesDatasetsDatasetIDRowsRole(str, Enum):
    r"""The role of the prompt message"""

    SYSTEM = "system"
    ASSISTANT = "assistant"
    USER = "user"
    EXCEPTION = "exception"
    TOOL = "tool"
    PROMPT = "prompt"
    CORRECTION = "correction"
    EXPECTED_OUTPUT = "expected_output"


class PostV2ResourcesDatasetsDatasetIDRows2ResourcesType(str, Enum):
    IMAGE_URL = "image_url"


class PostV2ResourcesDatasetsDatasetIDRows2ImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""
    detail: NotRequired[str]
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class PostV2ResourcesDatasetsDatasetIDRows2ImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""

    detail: Optional[str] = None
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class PostV2ResourcesDatasetsDatasetIDRows22TypedDict(TypedDict):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesType
    image_url: PostV2ResourcesDatasetsDatasetIDRows2ImageURLTypedDict


class PostV2ResourcesDatasetsDatasetIDRows22(BaseModel):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesType

    image_url: PostV2ResourcesDatasetsDatasetIDRows2ImageURL


class PostV2ResourcesDatasetsDatasetIDRows2Type(str, Enum):
    TEXT = "text"


class PostV2ResourcesDatasetsDatasetIDRows21TypedDict(TypedDict):
    r"""Text content part of a prompt message"""

    type: PostV2ResourcesDatasetsDatasetIDRows2Type
    text: str


class PostV2ResourcesDatasetsDatasetIDRows21(BaseModel):
    r"""Text content part of a prompt message"""

    type: PostV2ResourcesDatasetsDatasetIDRows2Type

    text: str


PostV2ResourcesDatasetsDatasetIDRowsContent2TypedDict = Union[
    PostV2ResourcesDatasetsDatasetIDRows21TypedDict,
    PostV2ResourcesDatasetsDatasetIDRows22TypedDict,
]


PostV2ResourcesDatasetsDatasetIDRowsContent2 = Union[
    PostV2ResourcesDatasetsDatasetIDRows21, PostV2ResourcesDatasetsDatasetIDRows22
]


PostV2ResourcesDatasetsDatasetIDRowsContentTypedDict = Union[
    str, List[PostV2ResourcesDatasetsDatasetIDRowsContent2TypedDict]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


PostV2ResourcesDatasetsDatasetIDRowsContent = Union[
    str, List[PostV2ResourcesDatasetsDatasetIDRowsContent2]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


class PostV2ResourcesDatasetsDatasetIDRowsType(str, Enum):
    FUNCTION = "function"


class PostV2ResourcesDatasetsDatasetIDRowsFunctionTypedDict(TypedDict):
    name: str
    arguments: str
    r"""JSON string arguments for the functions"""


class PostV2ResourcesDatasetsDatasetIDRowsFunction(BaseModel):
    name: str

    arguments: str
    r"""JSON string arguments for the functions"""


class PostV2ResourcesDatasetsDatasetIDRowsToolCallsTypedDict(TypedDict):
    type: PostV2ResourcesDatasetsDatasetIDRowsType
    function: PostV2ResourcesDatasetsDatasetIDRowsFunctionTypedDict
    id: NotRequired[str]
    index: NotRequired[float]


class PostV2ResourcesDatasetsDatasetIDRowsToolCalls(BaseModel):
    type: PostV2ResourcesDatasetsDatasetIDRowsType

    function: PostV2ResourcesDatasetsDatasetIDRowsFunction

    id: Optional[str] = None

    index: Optional[float] = None


class PostV2ResourcesDatasetsDatasetIDRowsMessagesTypedDict(TypedDict):
    role: PostV2ResourcesDatasetsDatasetIDRowsRole
    r"""The role of the prompt message"""
    content: PostV2ResourcesDatasetsDatasetIDRowsContentTypedDict
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""
    tool_calls: NotRequired[
        List[PostV2ResourcesDatasetsDatasetIDRowsToolCallsTypedDict]
    ]


class PostV2ResourcesDatasetsDatasetIDRowsMessages(BaseModel):
    role: PostV2ResourcesDatasetsDatasetIDRowsRole
    r"""The role of the prompt message"""

    content: PostV2ResourcesDatasetsDatasetIDRowsContent
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""

    tool_calls: Optional[List[PostV2ResourcesDatasetsDatasetIDRowsToolCalls]] = None


class PostV2ResourcesDatasetsDatasetIDRowsRequestBodyTypedDict(TypedDict):
    messages: List[PostV2ResourcesDatasetsDatasetIDRowsMessagesTypedDict]
    r"""Input message(s) of the dataset row"""
    expected_output: NotRequired[Nullable[str]]
    r"""Reference of the dataset row"""


class PostV2ResourcesDatasetsDatasetIDRowsRequestBody(BaseModel):
    messages: List[PostV2ResourcesDatasetsDatasetIDRowsMessages]
    r"""Input message(s) of the dataset row"""

    expected_output: OptionalNullable[str] = UNSET
    r"""Reference of the dataset row"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["expected_output"]
        nullable_fields = ["expected_output"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class PostV2ResourcesDatasetsDatasetIDRowsRequestTypedDict(TypedDict):
    dataset_id: str
    r"""Dataset ID"""
    request_body: NotRequired[PostV2ResourcesDatasetsDatasetIDRowsRequestBodyTypedDict]


class PostV2ResourcesDatasetsDatasetIDRowsRequest(BaseModel):
    dataset_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Dataset ID"""

    request_body: Annotated[
        Optional[PostV2ResourcesDatasetsDatasetIDRowsRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class PostV2ResourcesDatasetsDatasetIDRowsResourcesRole(str, Enum):
    r"""The role of the prompt message"""

    SYSTEM = "system"
    ASSISTANT = "assistant"
    USER = "user"
    EXCEPTION = "exception"
    TOOL = "tool"
    PROMPT = "prompt"
    CORRECTION = "correction"
    EXPECTED_OUTPUT = "expected_output"


class PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicResponseType(str, Enum):
    IMAGE_URL = "image_url"


class PostV2ResourcesDatasetsDatasetIDRows2ResourcesImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""
    id: NotRequired[str]
    r"""The orq.ai id of the image"""
    detail: NotRequired[str]
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class PostV2ResourcesDatasetsDatasetIDRows2ResourcesImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded data URI."""

    id: Optional[str] = None
    r"""The orq.ai id of the image"""

    detail: Optional[str] = None
    r"""Specifies the detail level of the image. Currently only supported with OpenAI models"""


class PostV2ResourcesDatasetsDatasetIDRows2Resources2TypedDict(TypedDict):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicResponseType
    image_url: PostV2ResourcesDatasetsDatasetIDRows2ResourcesImageURLTypedDict


class PostV2ResourcesDatasetsDatasetIDRows2Resources2(BaseModel):
    r"""The image part of the prompt message. Only supported with vision models."""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicResponseType

    image_url: PostV2ResourcesDatasetsDatasetIDRows2ResourcesImageURL


class PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicType(str, Enum):
    TEXT = "text"


class PostV2ResourcesDatasetsDatasetIDRows2Resources1TypedDict(TypedDict):
    r"""Text content part of a prompt message"""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicType
    text: str


class PostV2ResourcesDatasetsDatasetIDRows2Resources1(BaseModel):
    r"""Text content part of a prompt message"""

    type: PostV2ResourcesDatasetsDatasetIDRows2ResourcesPublicType

    text: str


PostV2ResourcesDatasetsDatasetIDRowsContentResources2TypedDict = Union[
    PostV2ResourcesDatasetsDatasetIDRows2Resources1TypedDict,
    PostV2ResourcesDatasetsDatasetIDRows2Resources2TypedDict,
]


PostV2ResourcesDatasetsDatasetIDRowsContentResources2 = Union[
    PostV2ResourcesDatasetsDatasetIDRows2Resources1,
    PostV2ResourcesDatasetsDatasetIDRows2Resources2,
]


PostV2ResourcesDatasetsDatasetIDRowsResourcesContentTypedDict = Union[
    str, List[PostV2ResourcesDatasetsDatasetIDRowsContentResources2TypedDict]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


PostV2ResourcesDatasetsDatasetIDRowsResourcesContent = Union[
    str, List[PostV2ResourcesDatasetsDatasetIDRowsContentResources2]
]
r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""


class PostV2ResourcesDatasetsDatasetIDRowsResourcesType(str, Enum):
    FUNCTION = "function"


class PostV2ResourcesDatasetsDatasetIDRowsResourcesFunctionTypedDict(TypedDict):
    name: str
    arguments: str
    r"""JSON string arguments for the functions"""


class PostV2ResourcesDatasetsDatasetIDRowsResourcesFunction(BaseModel):
    name: str

    arguments: str
    r"""JSON string arguments for the functions"""


class PostV2ResourcesDatasetsDatasetIDRowsResourcesToolCallsTypedDict(TypedDict):
    type: PostV2ResourcesDatasetsDatasetIDRowsResourcesType
    function: PostV2ResourcesDatasetsDatasetIDRowsResourcesFunctionTypedDict
    id: NotRequired[str]
    index: NotRequired[float]


class PostV2ResourcesDatasetsDatasetIDRowsResourcesToolCalls(BaseModel):
    type: PostV2ResourcesDatasetsDatasetIDRowsResourcesType

    function: PostV2ResourcesDatasetsDatasetIDRowsResourcesFunction

    id: Optional[str] = None

    index: Optional[float] = None


class PostV2ResourcesDatasetsDatasetIDRowsResourcesMessagesTypedDict(TypedDict):
    role: PostV2ResourcesDatasetsDatasetIDRowsResourcesRole
    r"""The role of the prompt message"""
    content: PostV2ResourcesDatasetsDatasetIDRowsResourcesContentTypedDict
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""
    tool_calls: NotRequired[
        List[PostV2ResourcesDatasetsDatasetIDRowsResourcesToolCallsTypedDict]
    ]


class PostV2ResourcesDatasetsDatasetIDRowsResourcesMessages(BaseModel):
    role: PostV2ResourcesDatasetsDatasetIDRowsResourcesRole
    r"""The role of the prompt message"""

    content: PostV2ResourcesDatasetsDatasetIDRowsResourcesContent
    r"""The contents of the user message. Either the text content of the message or an array of content parts with a defined type, each can be of type `text` or `image_url` when passing in images. You can pass multiple images by adding multiple `image_url` content parts."""

    tool_calls: Optional[
        List[PostV2ResourcesDatasetsDatasetIDRowsResourcesToolCalls]
    ] = None


class PostV2ResourcesDatasetsDatasetIDRowsResponseBodyTypedDict(TypedDict):
    r"""Expected dataset row model when talking to the API."""

    id: str
    r"""The id of the resource"""
    messages: List[PostV2ResourcesDatasetsDatasetIDRowsResourcesMessagesTypedDict]
    r"""Input message(s) of the dataset row"""
    expected_output: NotRequired[Nullable[str]]
    r"""Reference of the dataset row"""


class PostV2ResourcesDatasetsDatasetIDRowsResponseBody(BaseModel):
    r"""Expected dataset row model when talking to the API."""

    id: str
    r"""The id of the resource"""

    messages: List[PostV2ResourcesDatasetsDatasetIDRowsResourcesMessages]
    r"""Input message(s) of the dataset row"""

    expected_output: OptionalNullable[str] = UNSET
    r"""Reference of the dataset row"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["expected_output"]
        nullable_fields = ["expected_output"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
